H = {};

H.Emotion =
{
	point 	= "point",
	sleep 	= "sleep",
	angry 	= "angry",
	blush 	= "blush",
	dance 	= "dance",
	clap 		= "clap",
	comfort 	= "comfort",
	drink 		= "drink",
	eat 		= "eat",
	laugh 	= "laugh",
	kneel 	= "kneel",
	no 		= "no",
	otl 		= "otl",
	pat 		= "pat",
	plead 	= "plead",
	ready 	= "ready",
	sad 		= "sad",
	slap 		= "slap",
	surprise 	= "surprise",
	taunt 	= "taunt",
	thanks 	= "thanks",
	thunder 	= "thunder",
	useup 	= "useup",
	victory 	= "victory",
	yes 		= "yes",
	wave 	= "wave",
	boo 		= "boo",
	charge 	= "charge",
	dislike 	= "dislike",
	panic 	= "panic",
	salute 	= "salute",
	smile 		= "smile",
	sorry 	= "sorry",
	think 		= "think",
	blueflag 	= "blueflag",
	twoflag 	= "twoflag",
	whiteflag 	= "whiteflag",
	sing 		= "sing",
	jump 		= "jump",
}

H.Outlet =
{
	outlet0  =  0,
	outlet1  =  1,
	outlet2  =  2,
	outlet3  =  3,
	outlet4  =  4,
	outlet5  =  5,
	outlet6  =  6,
	outlet7  =  7,
	outlet8  =  8,
	outlet9  =  9,
	outlet10 =  10,
	outlet11 =  11,
	outlet12 =  12,
	outlet13 =  13,
	outlet14 =  14,
	outlet15 =  15,
	outlet16 =  16,
	outlet17 =  17,
	outlet18 =  18,
	outlet19 =  19,
	outlet20 =  20,
}

H.Percussion =
{
	tambourine	= 1,
	triangle	= 2,
	cymbal		= 3,
	hihatclose	= 4,
	hihatopen	= 5,
	kick		= 6,
	snare		= 7,
	tomtom1		= 8,
	tomtom2		= 9,
	tomtom3		= 10,
	fx1			= 20,
	fx2			= 21,
	fx3			= 22,
	fx4			= 23,
	fx5			= 24,
	fx6			= 25,
	fx7			= 26,
	fx8			= 27,
	fx9			= 28,
	fx10		= 29,
	fx11		= 30,
	fx12		= 31,
	fx13		= 32,
	fx14		= 33,
	fx15		= 34,
	fx16		= 35,
	fx17		= 36,
	fx18		= 37,
	fx19		= 38,
	fx20		= 39,
}

H.Instrument = 
{
	abass		= 1,
	ebass		= 2,
	aguitar		= 3,
	accordion	= 4,
}

H.Tactic = 
{
	smile		= 9,
	star		= 10,
	heart		= 11,
	bomb		= 12,
	skull		= 13,
}

--------------------------------------------------------------------------------------------------------------------------------------------------------
--[[
ChangeQueue = {}

function ChangeQueue:New(boxId)
  o = {}
  setmetatable(o, self)
  self.__index = self;

  o.first  = 0;
  o.last  = -1;

  ChangeQueue[boxId] = o;
  return o;
end

function ChangeQueue:addLast(func)
  self.last = self.last + 1
  self[self.last] = func;
end

function ChangeQueue:popFirst(func)
  if (self.first > self.last) then return nil; end
  local value = self[self.first];
  self[self.first] = nil;
  self.first = self.first + 1;
  return value;
end

function ChangeQueue:getFirst()
  if (self.first > self.last) then return nil; end
  return self[self.first];
end

function ChangeQueue:empty()
  return self.first > self.last;
end

function ChangeQueue:resume()
  if (self.co == nil) then
    self.co = coroutine.create(function() self:update(); end);
    print("co create");
  end
  print(coroutine.resume(self.co));
end

function ChangeQueue:update()
  while true do
    while (self:empty()) do
      coroutine.yield();
    end
    f = self:getFirst();
    f();
    coroutine.yield();
    self:popFirst();
  end
end
--]]

--------------------------------------------------------------------------------------------------------------------------------------------------------
--[[
function _LBoxSetPos(boxId, x, y, z, t)
  print("pos", boxId, x, y, z, t);
  ChangeQueue[boxId]:resume();
end

function _LBoxSetAngle(boxId, x, y, z, t)
  print("angle", boxId, x, y, z, t);
  ChangeQueue[boxId]:resume();
end

function _LBoxSetColor(boxId, x, y, z, t)
  print("color", boxId, x, y, z, t);
  ChangeQueue[boxId]:resume();
end

function _LBoxSetEnvColor(boxId, x, y, z, t)
  print("envcolor", boxId, x, y, z, t);
  ChangeQueue[boxId]:resume();
end

function _LBoxSetScale(boxId, scale, t)
  print("scale", boxId, scale, t);
  ChangeQueue[boxId]:resume();
end

function _LBoxSetSensor(boxId, distIn, distOut)
  print("sensor", boxId, distIn, distOut);
end

function _LBoxPlaySound(boxId, channel, str)
  print("playsound", boxId, channel, str);
end

function _LBoxSetPos(boxId, when, x, y, z, t)
  print("setpos ", boxId, when, x, y,z, t);
end

function _LBoxSetPoslinear(boxId, when, x, y, z, t)
  print("setpos linear ", boxId, when, x, y,z, t);
end

function _LBoxJump(boxId, when, height)
  print("jump ", boxId, when, height);
end

function _LBoxStartAnimation(boxId, when, height)
  print("setpos linear ", boxId, when, height);
end
--]]

--[[
function LBoxDo(box, func)
  local boxChangeQueue = ChangeQueue[box.boxId];
  local empty = boxChangeQueue:empty();

  boxChangeQueue:addLast(func);
  if (empty) then boxChangeQueue:resume() end;
end

function LBoxSetPos(box, x, y, z, t)
  LBoxDo(box, function() _LBox.SetPos(box.boxId, x, y, z, t) end);
end

function LBoxSetAngle(box, x, y, z, t)
  LBoxDo(box, function() _LBox.SetAngle(box.boxId, x, y, z, t); end);
end

function LBoxSetColor(box, x, y, z, t)
  LBoxDo(box, function() _LBox.SetColor(box.boxId, x, y, z, t); end);
end

function LBoxSetEnvColor(box, x, y, z, t)
  LBoxDo(box, function() _LBox.SetEnvColor(box.boxId, x, y, z, t); end);
end

function LBoxSetScale(box, scale, t)
  LBoxDo(box, function() _LBox.SetScale(box.boxId, x, y, z, t); end);
end
--]]

function H.GetGameTime()
  return _LBox.GetGameTime();
end

function H.GetPlayerName()
  return _LBox.GetPlayerName();
end

function H.SetSensor(distIn, distOut)
  if (g_currentBox ~= nil) then
    _LBox.SetSensor(g_currentBox.boxId, distIn, distOut);
  end
end

function H.PlaySound(channel, str)
  if (g_currentBox ~= nil) then
    _LBox.PlaySound(g_currentBox.boxId, channel, str);
  end
end

function H.SetPercussion(channel, percussion)
  if (g_currentBox ~= nil) then
    _LBox.SetPercussion(g_currentBox.boxId, channel, percussion);
  end
end

function H.SetInstrument(channel, instrument)
  if (g_currentBox ~= nil) then
    _LBox.SetInstrument(g_currentBox.boxId, channel, instrument);
  end
end

function H.SetPos(objId, when, x, y, z, t)
  if (g_currentBox ~= nil) then
    _LBox.SetPos(g_currentBox.boxId, objId, when, x, y, z, t);
  end
end

function H.SetPosLinear(objId, when, x, y, z, t)
  if (g_currentBox ~= nil) then
    _LBox.SetPosLinear(g_currentBox.boxId, objId, when, x, y, z, t);
  end
end

function H.Jump(objId, when, height)
  if (g_currentBox ~= nil) then
    _LBox.Jump(g_currentBox.boxId, objId, when, height);
--  _LBox.OutputDebugString(tostring(g_currentBox.boxId)..","..tostring(objId)..","..tostring(when)..","..tostring(height));
  end
end

function H.StartAnimation(objId, when, aniName, startTime, stopTime, speed, blendTime)
  if (g_currentBox ~= nil) then
    _LBox.StartAnimation(g_currentBox.boxId, objId, when, aniName, startTime or 0, stopTime or 0, speed or 1, blendTime or 0);
  end
end

function H.RegisterMenu(menuStr, menuNum)
  if (g_currentBox ~= nil) then
    _LBox.RegisterMenu(g_currentBox.boxId, menuStr, menuNum);
  end
end

function H.Say(when, str)
  if (g_currentBox ~= nil) then
	_LBox.Say(g_currentBox.boxId, when, str, 1, 0, 0);
  end
end

function H.SayNoBalloon(when, str)
  if (g_currentBox ~= nil) then
    _LBox.Say(g_currentBox.boxId, when, str, 0, 0, 0);
  end
end

function H.SayAll(when, str)
  if (g_currentBox ~= nil) then
    _LBox.Say(g_currentBox.boxId, when, str, 1, 1, 0);
  end
end

function H.SayAllNoBalloon(when, str)
  if (g_currentBox ~= nil) then
    _LBox.Say(g_currentBox.boxId, when, str, 0, 1, 0);
  end
end

function H.AlertAll(when, str)
  if (g_currentBox ~= nil) then
    _LBox.Say(g_currentBox.boxId, when, str, 1, 1, 1);
  end
end

function H.AlertAllNoBalloon(when, str)
  if (g_currentBox ~= nil) then
    _LBox.Say(g_currentBox.boxId, when, str, 0, 1, 1);
  end
end

function H.Target(when, name, duration)
  if (g_currentBox ~= nil) then
    _LBox.Target(g_currentBox.boxId, when, name, duration);
  end
end

function H.SetOutletCount(count)
  if (g_currentBox ~= nil) then
    _LBox.SetOutletCount(g_currentBox.boxId, count);
  end
end

function H.Glow(objId, when, duration, r, g, b)
  if (g_currentBox ~= nil) then
    _LBox.Glow(g_currentBox.boxId, objId, when, duration, r, g, b);
  end
end

function H.StartAnimationNow(objId, aniName, startTime, stopTime, speed, blendTime)
  if (g_currentBox ~= nil) then
    _LBox.StartAnimation(g_currentBox.boxId, objId, -1, aniName, startTime or 0, stopTime or 0, speed or 1, blendTime or 0);
  end
end

function H.SetPosNow(objId, x, y, z, t)
  if (g_currentBox ~= nil) then
    _LBox.SetPos(g_currentBox.boxId, objId, -1, x, y, z, t);
  end
end

function H.JumpNow(objId, height)
  if (g_currentBox ~= nil) then
    _LBox.Jump(g_currentBox.boxId, objId, -1, height);
  end
end

function H.GlowNow(objId, duration, r, g, b)
  if (g_currentBox ~= nil) then
    _LBox.Glow(g_currentBox.boxId, objId, -1, duration, r, g, b);
  end
end

function H.Scale(objId, when, duration, scale)
  if (g_currentBox ~= nil) then
    _LBox.Scale(g_currentBox.boxId, objId, when, duration, scale);
  end
end

function H.SetSign(objId, sign)
  if (g_currentBox ~= nil) then
    _LBox.SetSign(g_currentBox.boxId, objId, sign);
  end
end

function H.PlayJukeBoxSong(index)
  if (g_currentBox ~= nil) then
    _LBox.PlayJukeBoxSong(g_currentBox.boxId, index);
  end
end

function H.ResumeJukeBoxSong()
  if (g_currentBox ~= nil) then
    _LBox.ResumeJukeBoxSong(g_currentBox.boxId);
  end
end

function H.PlayJukeBoxNextSong()
  if (g_currentBox ~= nil) then
    _LBox.PlayJukeBoxNextSong(g_currentBox.boxId);
  end
end

function H.PlayJukeBoxPrevSong()
  if (g_currentBox ~= nil) then
    _LBox.PlayJukeBoxPrevSong(g_currentBox.boxId);
  end
end

function H.ReplayJukeBoxSong()
  if (g_currentBox ~= nil) then
    _LBox.ReplayJukeBoxSong(g_currentBox.boxId);
  end
end

function H.PauseJukeBoxSong()
  if (g_currentBox ~= nil) then
    _LBox.PauseJukeBoxSong(g_currentBox.boxId);
  end
end

function H.SetJukeBoxVolume(volume)
  if (g_currentBox ~= nil) then
    _LBox.SetJukeBoxVolume(g_currentBox.boxId, volume);
  end
end


function H.EnableSoundCallback(enable)
  if (g_currentBox ~= nil) then
    _LBox.EnableSoundCallback(enable);
  end
end

function H.Broadcast(msg, param1, param2)
  if (g_currentBox ~= nil) then
    _LBox.Broadcast(g_currentBox.boxId, msg, param1, param2);
  end
end

--------------------------------------------------------------------------------------------------------------------------------------------------------
LBoxList = {}
g_currentBox = nil;

function LBox_LoadScript(boxId, f)
--	local f = assert(loadstring(scriptStr));
--        _LBox.OutputDebugString(""..f);

	local lbox = {};
	LBoxList[boxId] = lbox;

	setmetatable(lbox, {__index = _G});
	setfenv(f, lbox);

	lbox.boxId = boxId;
	f();

	if (lbox.OnInit) then
	  g_currentBox = lbox;
	  lbox.OnInit();
	end

--	ChangeQueue:New(boxId);
--	for k, v in pairs(M) do _LBox.OutputDebugString(tostring(k)..", "..tostring(v)) end
end

function LBox_DispatchEvent(boxId, event, ...)
	local box = LBoxList[boxId];
	g_currentBox = box;
	if (box and box[event]) then
	  box[event](...);
	end
end

function LBox_Update(currTime, frameTime)
	for _, box in pairs(LBoxList) do
		box.Update(currTime, frameTime);
	end
end

function LBox_Resume(boxId)
--  local boxChangeQueue = ChangeQueue[boxId];
--  if (boxChangeQueue) then
--    boxChangeQueue:resume();
--  end
end

function LBox_DeleteBox(boxId)
  LBoxList[boxId] = nil;
--  ChangeQueue[boxId] = nil;
end

function LBox_SetOutlet(boxId, ...)
  local box = LBoxList[boxId];
  if (box) then
    box.outlet = {...}
  end
--[[
  _LBox.OutputDebugString("boxid: "..boxId);
  if (box) then
    for k, v in pairs(box.outlet) do _LBox.OutputDebugString(tostring(k)..": "..tostring(v)) end
  end
--]]
end

----------------------------------------------------------------------------------------------------------------------------------------------------------------
--[==[
LBox_LoadScript(1234, [[
function OnClicked(box)
  if (box.up) then
      LBoxSetPos(box, 1, 0, 0, 0, 1);
      box.up = nil
  else
--      LBoxSetPos(box, 1, 0, 0, 1, 1);
--      LBoxSetPos(box, 2, 0, 0, 3, 1);
      LBoxJump(box, 2, 2);
      LBoxStartAnimation(box, 1, LBoxEmotion.sing);
      box.up = true;
      LBoxPlaySound(box, 0, "c[1] e g  e c");
  end
--  LBoxPlaySound(box, 0, "c[1] d e f2[2] g a8 b8 >c8");
--  LBoxPlaySound(box, 0, "r8 c d e f2 g a8 b8 >c8");
end

function OnInit(box)
    LBoxRegisterMenu(box, "Clicked", 1);
end

function OnMenu(box, menuNum)
    OnClicked(box);
end

]]);

do
  local box = LBoxList[1234];
  box["OnClicked"](box);
end
--]==]

